.AUTOPARAGRAPH
.LEFT MARGIN 5
.RIGHT MARGIN 72
.NOFILL
                                                         
                                                             
.B 20
.CENTER
Computer Corporation of America
.CENTER
Terminal Driver Modifications for RSX-11M V3.2A
.b 2
.center
01-MAR-80
.page
.fill
.hl 1 INTRODUCTION
.p
.hl 2 General Description
.p
  The Computer Corporation of America RSX-11M V3.2A Full Duplex Terminal
Driver modifications allow increased flexability and functionality in the
use of a RSX system.
.p
  The driver modifications provide the following functions:
.list
.le RUBOUTS and CONTROL-R are echoed when echo is suppressed.  This 
is needed to support the TYMNET network.
.le BACKSPACE (CONTROL-H) and CONTROL-A are treated like RUBOUT.
.le The last character typed by the user is returned to the
unsolicited input ast routine. The unmodified driver returns the first
character in the typeahead
buffer.  This is needed for the execution abort function of COMET to
work properly.  If ESCAPE is not the first unsolicited character typed
the unmodified driver will not pass the ESCAPE character to the COMET
unsolicited input AST routine.
.le A new function IO.DIS (function code 3000) has been implemented.  This
function will hang up DZ-11 lines that are set as REMOTE.
.le REMOTE lines can be answered at speeds selected with the SET /SPEED
command.
.le An AST routine can be specified for ANSWER or HANGUP of REMOTE lines.
.endlist
.page
.hl 1 Use of the Modified Terminal Driver
.hl 2 Hangup/Answer AST support
.p
  The RSX-11M V3.2A Terminal Driver was modified to provide support of
hangup and answer ASTs.  The selection of this option may be made at
attach time along with specification of typeahead and optionaly control-C
ASTs.  The form of the attach QIO is:
.b 2
.nf
	QIO$	IO.ATA[!TF.NOT],....,<ast,[parameter2][,ast2][,ast3]>
.f
.p
  Where:
.list
.le ast is the unsolicited input AST routine address.
.le parameter2 is a line identification parameter which will be returned
to the AST Routine when an AST occurs.
.le ast2 is the control-C AST routine Address.
.le ast3 is the answer/hangup AST routine address.
.endlist
The optional answer/hangup ast routine address is the addition to the attach
directive syntax.  This word must be zero in tasks which are
attaching a terminal with typeahead but without answer/hangup ASTs.
.p
 When the AST routine is called the top word of the task's stack contains a parameter.
The high order byte is the line 
identification byte.  The low byte contains a zero if the AST was
caused by a hangup and a one if the AST was caused by answering the line.
.page
.hl 2 Disconnect function 
.p
  The Terminal driver was modified to provide a disconnect function.  This
function allows a task attached to a remote line to hang up the line.  The form
of this function is:
.nf
.b 2
	IO.DIS=3000
	   .
	   .
	   .
QIO$	IO.DIS,....
.b 2
.f
This routine will currently function with the DZ-11 line multiplexer.  For
other devices this function will have no effect.
.p
  Note that the function code must be assigned the value 3000 explicitly
since 3000 is not the default value of IO.DIS.
.page
.hl 1 Internal Driver Description
.hl 2 Hangup/Answer AST support
.p
  The hangup of a line is detected in the RSX-11M Version 3.2A Terminal Driver module TTMOD
routine MHUP.  This routine handles the processing of a disconnect of
all REMOTE lines,  independent of their physical type.  The routine 
FPAST1 is then called to issue the AST to the task attatched to the
terminal.  The answer AST is detected similarly in the routine MANS (located in TTMOD).
.p
  A new AST queueing routine FPAST1,  in the Terminal Driver Module TTFP,  allocates a block of pool for the AST
block.  The block is filled with the required parameters for automatic deletion
on dequeueing.  The upper byte of the parameter word is set to the
parameter specified on attach and the low order byte is set to zero
for hangup or one for answer.  The AST Block is then queued for the 
task.
.p
  The AST routine address specified in the attach statement is 
stored in the Terminal Driver AST Block.  The Terminal Driver AST Block
is a multipurpose data structure created when a terminal is attached with
typeahead AST support.  The first section is the AST control block which
is queued to the task for each unsolicited character.  The second section
of the block is a storage area for AST information.  This information
includes the parameter byte,  the unsolicited input AST routine address,  and
the control-C AST routine address.  One word was added to the end of this block
to contain the answer/hangup AST routine address.
.page
.hl 2 Disconnect
.p
  The Disconnect function is implimented by calling the correct device
dependent hangup routine.  The only device dependent routine currently
implimented is the DZ-11 routine (YZMOFF).
.hl 2 Unsolicited Input Modifications
.p
  The Unsolicited Input AST routine was modified so that the last character
entered into the typeahead buffer is returned to the AST routine.  This change
is needed when the notification subfunction bit is specified on the 
attach.  The original unsolicited character AST routine will always return
the first character in the typeahead buffer.  To support the execution abort
function in COMET it is necessary to pass the most recent character to COMET.
.p
  A new routine GLCTAB was added to module TTICH to get the last character
from the buffer.  The AST queueing routine in TTFP was modified to
call GLCTAB inplace of GCTAB the routine which will return the first
character in the typeahead buffer.
.page
.HL 1 Terminal Driver Modification procedure.
.p
  The driver changes require assembling the new driver modules,  taskbuilding the
driver, and using VMR to unload the old driver and load the new driver.
.p
  In order for the IO.DIS function code to work the driver database must 
be modidfied as well.  The driver database is located in the RSX-11M executive
module SYSTB.  SYSTB contains a word for each device specifying the legal
function codes.  The function code used for the IO.DIS function must be added
to the legal Terminal Driver functions.  The procedure for making these
changes requires
applying the correction file to the SYSTB module with SLP, reassembling the
module,  taskbuilding the executive and configuring the
system with VMR.  If the patches are applyed to the terminal driver without modifying the
driver database the IO.DIS function will have no effect but the other
modifications will function properly.
.hl 2 Building the modified RSX system.
.p
The UIC [11,40] should contain the distribution sources for the terminal driver
the correction files,  and command files used to modify the Terminal Driver.
.p
  The indirect command file [11,40]SYSTTMOD.CMD will apply the modifications
to the Terminal Driver and optionaly to the RSX Executive.  See TTDRVMOD.DOC for details of the patching process.
